module.exports = function (RED) {
  function Repeat(config) {
    RED.nodes.createNode(this, config);
    var self = this;
    self.on('input', function(msg) {
      if (msg._looper !== this.id) {
        msg.loops = 0;
        msg.remaining = msg.repetitions || config.repetitions;
        msg._looper = this.id;
      }
      if (msg.remaining > 0) {
        msg.remaining -= 1;
        msg.loops += 1;
        self.send(msg);
      } else {
        if (self.elseOutput) {
          self.send([null, msg]);
        }
      }
    });
  }
  RED.nodes.registerType('repeat', Repeat);
};
